// FastHash.dll
//
// C|[gCuł FastHashDll.lib gp΁ADLLƐÓIɃNł܂
// FastHash.dll݂ȂƓ삵ȂAvP[VɂȂĂ܂܂̂ŁA
// ÓIɃN̂͂ł邾
// FastHashDll.lib  Visual C++ .NET 2003 ō쐬Ă܂
// ÓIɃNꍇ͈ȉ̃RgOĂ
// #pragma comment(lib, "FastHashDll.lib")


#pragma once

// nbV^Cv̒`
#define HASH_CRC16          0x0001
#define HASH_CRC32          0x0002
#define HASH_MD5            0x0004
#define HASH_SHA1           0x0008
#define HASH_SHA256         0x0010
#define HASH_SHA384         0x0020
#define HASH_SHA512         0x0040
#define HASH_RIPEMD128      0x0080
#define HASH_RIPEMD160      0x0100
#define HASH_RIPEMD256      0x0200
#define HASH_RIPEMD320      0x0400

// nh̒`
typedef HANDLE HHASH_ENGINE;
typedef HANDLE HHASH_VALUE;



#ifdef __cplusplus
extern "C" {
#endif

HHASH_ENGINE WINAPI CreateHashEngineObject(DWORD dwHashType);
HHASH_VALUE WINAPI CreateHashValueObject(HHASH_ENGINE hEngine);
BOOL WINAPI CloseHashEngineHandle(HHASH_ENGINE hEngine);
BOOL WINAPI CloseHashValueHandle(HHASH_VALUE hValue);
BOOL WINAPI ComputeHash(HHASH_ENGINE hEngine, LPCVOID lpBuffer, DWORD dwNumberOfBytesToCompute);
BOOL WINAPI ModifyHash(HHASH_ENGINE hEngine, DWORD dwRemove, DWORD dwAdd);
BOOL WINAPI InitHashValue(HHASH_ENGINE hEngine);
DWORD WINAPI GetHashValue(HHASH_VALUE hValue, LPVOID lpBuffer, DWORD dwHashType);
DWORD WINAPI GetHashValueFromEngine(HHASH_ENGINE hEngine, LPVOID lpBuffer, DWORD dwHashType);
DWORD WINAPI GetHashType(HHASH_ENGINE hEngine);
DWORD WINAPI GetAllHashTypeNum(VOID);
BOOL WINAPI EnumHashType(DWORD dwIndex, LPTSTR lpName, LPDWORD lpdwHashType, LPDWORD lpdwHashValueSize);
BOOL WINAPI GetHashTypeInfo(DWORD dwHashType, LPTSTR lpName, LPDWORD lpdwHashValueSize);
VOID WINAPI HashValueToHashString(LPTSTR lpString, LPCVOID lpValue, DWORD dwHashSize, BOOL bSmallString);
BOOL WINAPI GetDllVersion(LPDWORD lpMajorVersion, LPDWORD lpMinorVersion);
BOOL WINAPI GetDllVersionString(LPTSTR lpBuffer);

#ifdef __cplusplus
}
#endif

